# комментарии начинаются с # и идут до конца строки

# скрипт GUI, нужен пакет Tk
package require Tk

# создаём все элементы
# окно с внутренним именем .form
toplevel .win
# внутри него невидимый фрейм
ttk::frame .win.carea
# уже в котором наш фрейм с рамкой и заголовком
ttk::labelframe .win.carea.form -text "заголовок"
# и кнопки cancel,ok (хотя их тоже можно было в отдельный фрейм)
ttk::button .win.carea.cancel -text "cancel"
ttk::button .win.carea.ok -text "ok"
# внутри формы - подсказка к полю ввода и само поле ввода
ttk::label .win.carea.form.prompt -text "подсказка"
ttk::entry .win.carea.form.entry

# теперь каждый фрейм сверстаем как таблицы 
# внутри окна у нас только один фрейм на всю единственную ячейку таблицы
grid .win.carea -row 0 -column 0 -sticky "nsew"
# разрешим строке и колонке растягиваться
grid rowconfigure .win 0 -weight 1
grid columnconfigure .win 0 -weight 1

# теперь фрейм .win.carea
grid .win.carea.form -row 0 -column 0 -columnspan 3 -sticky "nsew"
grid .win.carea.cancel -row 1 -column 1 -sticky "nsew"
grid .win.carea.ok -row 1 -column 2 -sticky "nsew"
grid columnconfigure .win.carea 0 -uniform same -weight 1
grid columnconfigure .win.carea 1 -uniform same -weight 1
grid columnconfigure .win.carea 2 -uniform same -weight 1
grid rowconfigure .win.carea 0 -weight 1

# и собственно элементы формы
grid .win.carea.form.prompt -row 0 -column 0 -sticky "nsew"
grid .win.carea.form.entry -row 0 -column 1 -sticky "nsew"
grid columnconfigure .win.carea.form 0 -weight 1
grid columnconfigure .win.carea.form 1 -weight 2

# скрываем основное окно
wm withdraw .
# запрещаем закрывать форму
# (вместо закрытий, просто свернём)
wm protocol .win WM_DELETE_WINDOW { wm iconify .win }

# действия для кнопки Ok
# создадим переменную
set BOX {}
.win.carea.ok configure -command {
	# получаем текст из поля ввода
	set text [ .win.carea.form.entry get ]
	# удалим лишние пробелы
	set text [ string trim $text ]
	# если не пусто - зададим значение глобальной переменной
	if { $text != {} } {
		global BOX 
		set BOX [ list 1 $text ]
	}
}
# и заодно уж cancel будет очищать поле ввода
.win.carea.cancel configure -command {
	.win.carea.form.entry delete 0 end
}
